# define driver name, version and release
%define		drvname	broadcom-wl
%define		drvver	5.100.82.112
%define		drvrel	7.mga2.nonfree

# define core kernel version we build against
%define 	kernver		3.4.32
%define		kernrel		2.mga2

# where to build
%define		topdir		${RPM_BUILD_DIR}/%{name}-%{_arch}

# source package
Name:		kmod-%{drvname}
Version:	%{drvver}
Release:	%mkrel 41
Summary:	Prebuilt %{drvname} modules for kernel-%{kernver}-%{kernrel}
License:	Freeware
URL:		http://www.broadcom.com/support/802.11/linux_sta.php
Group:		System/Kernel and hardware
ExclusiveArch:	%{ix86} x86_64

BuildRequires:	dkms-%{drvname} = %{drvver}-%{drvrel}
%ifarch %{ix86}
BuildRequires:	kernel-desktop586-devel-%{kernver}-%{kernrel}
%endif
BuildRequires:	kernel-desktop-devel-%{kernver}-%{kernrel}
BuildRequires:	kernel-netbook-devel-%{kernver}-%{kernrel}
BuildRequires:	kernel-server-devel-%{kernver}-%{kernrel}

%description
This package creates prebuilt %{drvname} kernel modules for core kernel.



##### mkflavour() ala core kernel #####
%define mkflavour()								\
%package -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}			\
Summary:	%{drvname} driver for kernel-%{1}-%{kernver}-%{kernrel}		\
License:	Commercial							\
URL:		http://www.broadcom.com/support/802.11/linux_sta.php		\
Group:		System/Kernel and hardware					\
Requires(post): dkms-minimal							\
Requires(preun): dkms-minimal							\
Requires:	%{drvname}-common >= %{drvver}-%{drvrel}			\
Requires:	kernel-%{1}-%{kernver}-%{kernrel}				\
Requires(post):	kernel-%{1}-%{kernver}-%{kernrel}				\
Requires(preun): kernel-%{1}-%{kernver}-%{kernrel}				\
Suggests:	%{drvname}-kernel-%{1}-latest					\
%ifarch %{ix86}									\
Conflicts:	arch(x86_64)							\
%endif										\
										\
%description -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}			\
Prebuilt dkms binary kernel modules for the %{drvname} driver version %{drvver} \
built for kernel-%{1}-%{kernver}-%{kernrel}.					\
										\
%files -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%dir /var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-%{1}-%{kernrel} \
/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-%{1}-%{kernrel}/* \
										\
%post -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%{_sbindir}/dkms install --binary -m %{drvname} -v %{drvver}-%{drvrel} -k %{kernver}-%{1}-%{kernrel} --rpm_safe_upgrade \
%{_sbindir}/dkms status -m %{drvname} -v %{drvver}-%{drvrel}			\
										\
%preun -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%{_sbindir}/dkms uninstall --binary -m %{drvname} -v %{drvver}-%{drvrel} -k %{kernver}-%{1}-%{kernrel} --rpm_safe_upgrade \
										\
										\
%package -n %{drvname}-kernel-%{1}-latest					\
Summary:	Virtual rpm for latest %{drvname}-kernel-%{1} driver		\
License:	Commercial							\
URL:		http://www.broadcom.com/support/802.11/linux_sta.php		\
Group:		System/Kernel and hardware					\
Requires:	%{drvname}-kernel-%{kernver}-%{1}-%{kernrel} = %{version}-%{release} \
%ifarch %{ix86}									\
Conflicts:	arch(x86_64)							\
%endif										\
										\
%description -n %{drvname}-kernel-%{1}-latest					\
This package is a virtual rpm that aims to make sure you always have the	\
latest prebuilt %{drvname} driver for kernel-%{1}.				\
										\
%files -n %{drvname}-kernel-%{1}-latest

%ifarch %{ix86}
%mkflavour desktop586
%endif

%mkflavour desktop
%mkflavour netbook
%mkflavour server


%prep
rm -rf %{topdir}

%build
%{_sbindir}/dkms add -m %{drvname} -v %{drvver}-%{drvrel} --dkmstree %{topdir}/var/lib/dkms-binary
%ifarch %{ix86}
%{_sbindir}/dkms build --no-prepare-kernel --no-clean-kernel -m %{drvname} -v %{drvver}-%{drvrel} \
	    -k %{kernver}-desktop586-%{kernrel} --kernelsourcedir /usr/src/linux-%{kernver}-desktop586-%{kernrel} \
	    --dkmstree %{topdir}/var/lib/dkms-binary
%endif
for flavour in desktop netbook server; do
    %{_sbindir}/dkms build --no-prepare-kernel --no-clean-kernel -m %{drvname} -v %{drvver}-%{drvrel} \
		-k %{kernver}-$flavour-%{kernrel} --kernelsourcedir /usr/src/linux-%{kernver}-$flavour-%{kernrel} \
		--dkmstree %{topdir}/var/lib/dkms-binary
done

%install
mkdir -p %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}
cp -a %{topdir}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-*-%{kernrel} \
      %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/
for dir in %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-*-%{kernrel}; do
    cp -a /usr/src/%{drvname}-%{drvver}-%{drvrel}/dkms.conf $dir/
    xz -6e $dir/*/module/wl.ko
done


%changelog

* Mon Feb 18 2013 tmb <tmb> 5.100.82.112-41.mga2
+ Revision: 399260
- rebuild for kernel-3.4.32-2.mga2
- rebuild for kernel-3.4.32-1.mga2
- require broadcom-wl-common to get correct blacklists and aliases
- rebuild for kernel-3.4.24-3.mga2
- rebuild for kernel-3.4.24-2.mga2
- rebuild for kernel-3.4.24-1.mga2
- rebuild for kernel-3.4.20-1.mga2
- rebuild for kernel-3.4.19-1.mga2
- rebuild for kernel-3.4.18-1.mga2
- rebuild for kernel-3.4.17-1.mga2
- rebuild for kernel-3.4.16-1.mga2
- rebuild for kernel-3.4.15-1.mga2
- build with fixed broadcom-wl
- rebuild for kernel-3.4.13-1.mga2
- rebuild for kernel-3.3.8-2.mga2 and broadcom-wl-5.100.82.112-5.mga2.nonfree
- rebuild for kernel-3.3.8-1.mga2
- build for kernel-3.3.6-2.mga2

* Sun May 13 2012 tmb <tmb> 5.100.82.112-26.mga2.nonfree
+ Revision: 235566
- build for kernel-3.3.6-1.mga2

* Thu May 10 2012 tmb <tmb> 5.100.82.112-25.mga2.nonfree
+ Revision: 235201
- build for kernel-3.3.5-1.mga2

* Sat Apr 28 2012 tmb <tmb> 5.100.82.112-24.mga2.nonfree
+ Revision: 233922
- rebuild for kernel-3.3.4-1.mga2

* Mon Apr 23 2012 tmb <tmb> 5.100.82.112-23.mga2.nonfree
+ Revision: 232873
- rebuild for kernel-3.3.3-1.mga2

* Wed Apr 04 2012 tmb <tmb> 5.100.82.112-22.mga2.nonfree
+ Revision: 228368
- rebuild for kernel-3.3.1-2.mga2

* Tue Apr 03 2012 tmb <tmb> 5.100.82.112-21.mga2.nonfree
+ Revision: 228075
- rebuild for kernel-3.3.1-1.mga2

* Sun Mar 25 2012 tmb <tmb> 5.100.82.112-20.mga2.nonfree
+ Revision: 226184
- rebuild for kernel-3.3.0-2.mga2

* Mon Mar 19 2012 tmb <tmb> 5.100.82.112-19.mga2.nonfree
+ Revision: 224372
- rebuild for kernel-3.3.0-1.mga2

* Sun Mar 11 2012 tmb <tmb> 5.100.82.112-18.mga2.nonfree
+ Revision: 222560
- rebuild for kernel 3.3-rc7

* Mon Mar 05 2012 tmb <tmb> 5.100.82.112-17.mga2.nonfree
+ Revision: 219301
- rebuild for kernel-3.3.0-0.rc6.1.mga2

* Sat Mar 03 2012 tmb <tmb> 5.100.82.112-16.mga2.nonfree
+ Revision: 217301
- rebuild for kernel-3.2.9-2.mga2

* Thu Mar 01 2012 tmb <tmb> 5.100.82.112-15.mga2.nonfree
+ Revision: 216399
- rebuild for kernel-3.2.9-1.mga2

* Sat Feb 25 2012 tmb <tmb> 5.100.82.112-13.mga2.nonfree
+ Revision: 214771
- rebuild for kernel-3.2.7-1.mga2

* Thu Feb 16 2012 tmb <tmb> 5.100.82.112-12.mga2.nonfree
+ Revision: 209783
- rebuild for kernel-3.2.6-3.mga2
- compress modules with xz

* Tue Feb 14 2012 tmb <tmb> 5.100.82.112-11.mga2.nonfree
+ Revision: 208935
- rebuild for kernel-3.2.6-2.mga2

* Sun Feb 12 2012 tmb <tmb> 5.100.82.112-10.mga2.nonfree
+ Revision: 208062
- rebuild for kernel-3.2.6-0.rc1.1.mga2

* Mon Feb 06 2012 tmb <tmb> 5.100.82.112-9.mga2.nonfree
+ Revision: 205604
- rebuild for kernel-3.2.5-1.mga2

* Thu Jan 26 2012 tmb <tmb> 5.100.82.112-8.mga2.nonfree
+ Revision: 201951
- rebuild for kernel-3.2.2-1.mga2

* Fri Jan 20 2012 tmb <tmb> 5.100.82.112-7.mga2.nonfree
+ Revision: 198863
- build with kernel-3.2.1-2.mga2

* Sun Jan 15 2012 tmb <tmb> 5.100.82.112-6.mga2.nonfree
+ Revision: 196454
- kernel-xen-pvops does not exist anymore
- build against kernel-3.2.1-1.mga2

* Sun Jan 15 2012 tmb <tmb> 5.100.82.112-5.mga2.nonfree
+ Revision: 196309
- fix package name to match kernel uname -r

* Thu Jan 05 2012 tmb <tmb> 5.100.82.112-4.mga2.nonfree
+ Revision: 191564
- build with kernel-3.2.0-1.mga2

* Thu Dec 29 2011 tmb <tmb> 5.100.82.112-3.mga2.nonfree
+ Revision: 188526
- build with kernel-3.2.0-0.rc7.2.mga2
- fix url

* Mon Dec 26 2011 tmb <tmb> 5.100.82.112-2.mga2.nonfree
+ Revision: 187935
- build with broadcom-wl-5.100.82.112-4.mga2.nonfree
- build for kernel-3.2.0-0.rc7.1.mga2

* Mon Dec 26 2011 tmb <tmb> 5.100.82.112-1.mga2.nonfree
+ Revision: 187879
- imported package kmod-broadcom-wl

